import * as grpcWeb from 'grpc-web';

import * as common_search$criteria_pb from '../common/search-criteria_pb';
import * as common_search$pagination_pb from '../common/search-pagination_pb';
import * as common_search$sort_pb from '../common/search-sort_pb';
import * as user_user_pb from '../user/user_pb';

import {
  CreateUserRequest,
  CreateUserResponse,
  DeleteUserRequest,
  DeleteUserResponse,
  ReadAllUsersRequest,
  ReadAllUsersResponse,
  ReadUserByIdRequest,
  ReadUserByUsernameRequest,
  ReadUserResponse,
  UpdateUserRequest,
  UpdateUserResponse} from './user-service_pb';

export class UserServiceClient {
  constructor (hostname: string,
               credentials: null | { [index: string]: string; },
               options: null | { [index: string]: string; });

  createUser(
    request: CreateUserRequest,
    metadata: grpcWeb.Metadata | undefined,
    callback: (err: grpcWeb.Error,
               response: CreateUserResponse) => void
  ): grpcWeb.ClientReadableStream<CreateUserResponse>;

  readUserById(
    request: ReadUserByIdRequest,
    metadata: grpcWeb.Metadata | undefined,
    callback: (err: grpcWeb.Error,
               response: ReadUserResponse) => void
  ): grpcWeb.ClientReadableStream<ReadUserResponse>;

  readUserByUsername(
    request: ReadUserByUsernameRequest,
    metadata: grpcWeb.Metadata | undefined,
    callback: (err: grpcWeb.Error,
               response: ReadUserResponse) => void
  ): grpcWeb.ClientReadableStream<ReadUserResponse>;

  updateUser(
    request: UpdateUserRequest,
    metadata: grpcWeb.Metadata | undefined,
    callback: (err: grpcWeb.Error,
               response: UpdateUserResponse) => void
  ): grpcWeb.ClientReadableStream<UpdateUserResponse>;

  deleteUser(
    request: DeleteUserRequest,
    metadata: grpcWeb.Metadata | undefined,
    callback: (err: grpcWeb.Error,
               response: DeleteUserResponse) => void
  ): grpcWeb.ClientReadableStream<DeleteUserResponse>;

  readAllUsers(
    request: ReadAllUsersRequest,
    metadata: grpcWeb.Metadata | undefined,
    callback: (err: grpcWeb.Error,
               response: ReadAllUsersResponse) => void
  ): grpcWeb.ClientReadableStream<ReadAllUsersResponse>;

}

export class UserServicePromiseClient {
  constructor (hostname: string,
               credentials: null | { [index: string]: string; },
               options: null | { [index: string]: string; });

  createUser(
    request: CreateUserRequest,
    metadata?: grpcWeb.Metadata
  ): Promise<CreateUserResponse>;

  readUserById(
    request: ReadUserByIdRequest,
    metadata?: grpcWeb.Metadata
  ): Promise<ReadUserResponse>;

  readUserByUsername(
    request: ReadUserByUsernameRequest,
    metadata?: grpcWeb.Metadata
  ): Promise<ReadUserResponse>;

  updateUser(
    request: UpdateUserRequest,
    metadata?: grpcWeb.Metadata
  ): Promise<UpdateUserResponse>;

  deleteUser(
    request: DeleteUserRequest,
    metadata?: grpcWeb.Metadata
  ): Promise<DeleteUserResponse>;

  readAllUsers(
    request: ReadAllUsersRequest,
    metadata?: grpcWeb.Metadata
  ): Promise<ReadAllUsersResponse>;

}

